
PJlist = [1:13]
x=[3.2507    0.4517    1.6612    3.1853  3.6646    3.9492]; % The H factor and B factors
S2_scale = 1;

htAr = [  x(2)    x(3)   x(4)];
bfAr = [x(1) x(5) x(6)]

SF_Iguess = 0.0281;


curr_measurementnum=1;
SPHyn = 1;

saveprefix = sprintf(['DataA'  num2str(PJlist(1)) num2str(PJlist(end))]);


%%

Res = 0.3434;

angles = importdata('anglesA.mat');
angles = angles(PJlist,:);
projections = importdata('ProjsA.mat');

projections = My_paddzero(projections,[size(projections,1)+40 size(projections,2)+40 size(projections,3)]);

MaskGaussian = importdata('MaskA.mat');
MaskGaussian = My_paddzero(MaskGaussian,size(projections));

projections = projections(2:end,2:end,PJlist);
MaskGaussian = MaskGaussian(2:end,2:end,PJlist);

projections = projections.*MaskGaussian;

tracing = importdata('rawModelA.mat');
model= tracing.atom_posInMask;
atoms = tracing.atomTypeInMask; %1S  2Mo  3Re

model(:,atoms==0)=[];
atoms(:,atoms==0)=[];

% model = model*Res; %in anglestrom

atomS = find(atoms==1|atoms==4);

%% group the S2 pairs: 
atoms_I = [];
atoms_II = [];
atoms_singleS = [];

n = 2; %grab first n nearest atoms

for i_p1 = atomS
%     i_p1

    if sum(atoms_I==i_p1)>0 ||sum(atoms_II==i_p1)>0 
        i_p1;
        continue;
    end

    x = sqrt(sum((repmat(model(1:2,i_p1),[1,size(model(:,atomS),2)])-model(1:2,atomS)).^2,1));
    minDist = zeros(1,n);
    nearbyAtoms = zeros(1,n);
    for i=1:n %exclude itself
      [minDist(i),indexAtom] = min(x);
      % remove for the next iteration the last smallest value:
      x(indexAtom) = 100;
      nearbyAtoms(i)=atomS(indexAtom);
    end
    
    if minDist(2)>1.5
        i_p1;
        minDist;
        atoms_singleS(end+1)=i_p1;
        continue;
    else
        atoms_I(end+1)=i_p1;
        atoms_II(end+1)=nearbyAtoms(2);
    end

end


figure;hold on
plot3(model(2,atoms_I),model(1,atoms_I),model(3,atoms_I),'b.');
plot3(model(2,atoms_II),model(1,atoms_II),model(3,atoms_II),'ro');
plot3(model(2,atoms_singleS),model(1,atoms_singleS),model(3,atoms_singleS),'b^');

%%
volSize= size(projections,1);


CropHalfWidth = 3; % in Pixel
cylinderRad = 2; % in Angstrom
cylinderRad_Large = 4; % in Angstrom

cylinderAtomBufferRad = 1; % in Angstrom

calcR_halfRad = 5;
calcR_halfRad_Large = 4;

[X,Y,~] = ndgrid(-calcR_halfRad:calcR_halfRad,-calcR_halfRad:calcR_halfRad,1:size(angles,1));
if SPHyn == 1
  useInd = find( (X.^2+Y.^2) < (calcR_halfRad+0.5)^2);
else
  useInd = 1:length(X(:));
end
clear X Y


[X,Y,~] = ndgrid(-calcR_halfRad_Large:calcR_halfRad_Large,-calcR_halfRad_Large:calcR_halfRad_Large,1:size(angles,1));
if SPHyn == 1
  useInd_Large = find( (X.^2+Y.^2) < (calcR_halfRad_Large+0.5)^2);
else
  useInd_Large = 1:length(X(:));
end
clear X Y

fixedfa_big = make_fixedfa(volSize, Res);
fixedfa_small = make_fixedfa(1+4*round(cylinderRad/Res), Res);


%%
atoms_INC = atoms;

Atomtype_INC = atoms_INC;

curr_atoms_INC = Atomtype_INC;
prev_atoms_INC = Atomtype_INC;

iterNum=0;
endFlag = 0;
Rar =[];

NumHalfScans = 1;
scanStepAr = [0.2];
scanFromCenAr = [1];
DeviationLimAr = [3];

RMSDTh = 0.2;%RMSDTh = scanStepAr

curr_model = model;
prev_model = model;
old_model = model;


IncInd = atoms_I; %which one to refine

%%
vacNum=4

while ~endFlag
    iterNum = iterNum+1
    
    %rescale using overall scale factor
    curr_Projs = My_create_volProjs_from_model_exact_HB_fixedfa_fainput(curr_model,curr_atoms_INC,[htAr 0],[bfAr 1],volSize, Res, CropHalfWidth, angles,fixedfa_big);
    curr_Projs = curr_Projs.*MaskGaussian;
    
    fun = @(x,xdata)sum(abs(xdata(:,1) - x*xdata(:,2)));
    opts = optimset('Display','off');
    
    SFar = zeros(1,size(curr_Projs,3));
    curr_Projs_scaled = zeros(size(curr_Projs));
    for i=1:size(curr_Projs,3)
        x0 = SF_Iguess;
        currExpP = projections(:,:,i);
        currCalcP = curr_Projs(:,:,i);
        SFar(i) = lsqcurvefit(fun,x0,[currExpP(:)  currCalcP(:)],0,[],[],opts);
        curr_Projs_scaled(:,:,i) = curr_Projs(:,:,i) * SFar(i);
    end
    currR = calcR_nonorm_YY(projections,curr_Projs_scaled)
    Rar(iterNum) = currR;
    

    localR_ar_C1 = zeros(1,length(IncInd));
    localR_ar_C2 = zeros(1,length(IncInd));
    localR_ar_C3 = zeros(1,length(IncInd));
    localR_ar_C4 = zeros(1,length(IncInd));
    
    localR_ar_pos = zeros(1,length(IncInd));
    
%         curr_IncInd = IncInd(randperm(length(IncInd)));

    curr_IncInd = IncInd;

    for i=1:length(curr_IncInd)           
      
        i
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        %C1
        curr_atoms_INC(atoms_I(i)) = vacNum;
        curr_atoms_INC(atoms_II(i)) = vacNum;

        [cylinderProjAr, cylinerIndsAr] = My_create_cylinder_proj_from_model_2D_fainput_parfor(curr_model, curr_atoms_INC, curr_IncInd(i), angles, [htAr 0],[bfAr 1], volSize, Res,CropHalfWidth, round(cylinderRad/Res), round(cylinderAtomBufferRad/Res),fixedfa_small );

        subProjs = zeros(size(cylinerIndsAr,2),size(cylinerIndsAr,2),size(cylinerIndsAr,3));
        for j=1:size(angles,1)
        subProjs(:,:,j) = projections(cylinerIndsAr(1,:,j),cylinerIndsAr(2,:,j),j);
        end

        subProjs_crop = My_stripzero(subProjs ,[calcR_halfRad*2+1 calcR_halfRad*2+1 size(angles,1)]);
        cylinderProjAr_crop = My_stripzero(cylinderProjAr ,[calcR_halfRad*2+1 calcR_halfRad*2+1 size(angles,1)]);

        cylinderProjAr_crop_scaled = zeros(size(cylinderProjAr_crop));
        for j=1:size(curr_Projs,3)
        cylinderProjAr_crop_scaled(:,:,j) = cylinderProjAr_crop(:,:,j)*SFar(j);
        end

        currR_C1 = calcR_nonorm_YY(subProjs_crop(useInd),cylinderProjAr_crop_scaled(useInd)); 
        

        %C2
        curr_atoms_INC(atoms_I(i)) = 1;
        curr_atoms_INC(atoms_II(i)) = vacNum;
        

        [cylinderProjAr, cylinerIndsAr] = My_create_cylinder_proj_from_model_2D_fainput_parfor(curr_model, curr_atoms_INC, curr_IncInd(i), angles, [htAr 0],[bfAr 1], volSize, Res,CropHalfWidth, round(cylinderRad/Res), round(cylinderAtomBufferRad/Res),fixedfa_small );

        subProjs = zeros(size(cylinerIndsAr,2),size(cylinerIndsAr,2),size(cylinerIndsAr,3));
        for j=1:size(angles,1)
          subProjs(:,:,j) = projections(cylinerIndsAr(1,:,j),cylinerIndsAr(2,:,j),j);
        end

        subProjs_crop = My_stripzero(subProjs ,[calcR_halfRad*2+1 calcR_halfRad*2+1 size(angles,1)]);
        cylinderProjAr_crop = My_stripzero(cylinderProjAr ,[calcR_halfRad*2+1 calcR_halfRad*2+1 size(angles,1)]);

        cylinderProjAr_crop_scaled = zeros(size(cylinderProjAr_crop));
        for j=1:size(curr_Projs,3)
          cylinderProjAr_crop_scaled(:,:,j) = cylinderProjAr_crop(:,:,j)*SFar(j);
        end
        
        currR_C2 = calcR_nonorm_YY(subProjs_crop(useInd),cylinderProjAr_crop_scaled(useInd)); 
        
        
        
        %C3
        curr_atoms_INC(atoms_I(i)) = vacNum;
        curr_atoms_INC(atoms_II(i)) = 1;

        [cylinderProjAr, cylinerIndsAr] = My_create_cylinder_proj_from_model_2D_fainput_parfor(curr_model, curr_atoms_INC, curr_IncInd(i), angles, [htAr 0],[bfAr 1],volSize, Res, CropHalfWidth, round(cylinderRad/Res), round(cylinderAtomBufferRad/Res),fixedfa_small );

        subProjs = zeros(size(cylinerIndsAr,2),size(cylinerIndsAr,2),size(cylinerIndsAr,3));
        for j=1:size(angles,1)
          subProjs(:,:,j) = projections(cylinerIndsAr(1,:,j),cylinerIndsAr(2,:,j),j);
        end

        subProjs_crop = My_stripzero(subProjs ,[calcR_halfRad*2+1 calcR_halfRad*2+1 size(angles,1)]);
        cylinderProjAr_crop = My_stripzero(cylinderProjAr ,[calcR_halfRad*2+1 calcR_halfRad*2+1 size(angles,1)]);

        cylinderProjAr_crop_scaled = zeros(size(cylinderProjAr_crop));
        for j=1:size(curr_Projs,3)
          cylinderProjAr_crop_scaled(:,:,j) = cylinderProjAr_crop(:,:,j)*SFar(j);
        end

        currR_C3 = calcR_nonorm_YY(subProjs_crop(useInd),cylinderProjAr_crop_scaled(useInd));

        %C4
        curr_atoms_INC(atoms_I(i)) = 1;
        curr_atoms_INC(atoms_II(i)) = 1;

        [cylinderProjAr, cylinerIndsAr] = My_create_cylinder_proj_from_model_2D_fainput_parfor(curr_model, curr_atoms_INC, curr_IncInd(i), angles, [htAr 0],[bfAr 1],volSize, Res, CropHalfWidth, round(cylinderRad/Res), round(cylinderAtomBufferRad/Res),fixedfa_small );

        subProjs = zeros(size(cylinerIndsAr,2),size(cylinerIndsAr,2),size(cylinerIndsAr,3));
        for j=1:size(angles,1)
          subProjs(:,:,j) = projections(cylinerIndsAr(1,:,j),cylinerIndsAr(2,:,j),j);
        end

        subProjs_crop = My_stripzero(subProjs ,[calcR_halfRad*2+1 calcR_halfRad*2+1 size(angles,1)]);
        cylinderProjAr_crop = My_stripzero(cylinderProjAr ,[calcR_halfRad*2+1 calcR_halfRad*2+1 size(angles,1)]);

        cylinderProjAr_crop_scaled = zeros(size(cylinderProjAr_crop));
        for j=1:size(curr_Projs,3)
          cylinderProjAr_crop_scaled(:,:,j) = cylinderProjAr_crop(:,:,j)*SFar(j);
        end

        currR_C4 = calcR_nonorm_YY(subProjs_crop(useInd),cylinderProjAr_crop_scaled(useInd))*S2_scale;
        
        
        localR_ar_C1(i) = currR_C1;
        localR_ar_C2(i) = currR_C2;
        localR_ar_C3(i) = currR_C3;
        localR_ar_C4(i) = currR_C4;
        
        [minV, minI] = min([currR_C1 currR_C2 currR_C3 currR_C4]);    
        
        switch minI
            case 1
                curr_atoms_INC(atoms_I(i)) = vacNum;
                curr_atoms_INC(atoms_II(i)) = vacNum;
            case 2
                curr_atoms_INC(atoms_I(i)) = 1;
                curr_atoms_INC(atoms_II(i)) = vacNum;
            case 3
                curr_atoms_INC(atoms_I(i)) = vacNum;
                curr_atoms_INC(atoms_II(i)) = 1;
            case 4
                curr_atoms_INC(atoms_I(i)) = 1;
                curr_atoms_INC(atoms_II(i)) = 1;
        end
          
        
    end
    
    localR_ar = [localR_ar_C1;localR_ar_C2;localR_ar_C3;localR_ar_C4];
%     save(sprintf('%s_Rar_iter_%d.mat',saveprefix,iterNum),'curr_model','localR_ar','curr_atoms_INC','SFar','curr_IncInd','Rar');
    
    prev_model_incinds = prev_model(:,IncInd);
    curr_model_incinds = curr_model(:,IncInd);
    RMSD = sqrt(mean(sum( (prev_model_incinds-curr_model_incinds).^2,1)));
    
    fprintf(1,'iter %d, %7.3f RMSD!\n',iterNum, RMSD);
    
    
    if sum(prev_atoms_INC~=curr_atoms_INC)==0
        fprintf(1,'iter %d, species converged!\n',iterNum);
        if RMSD < RMSDTh
            fprintf(1,'RMSD smaller than threshold %7.3f, terminate the loop!\n',RMSDTh);
            endFlag=1;
        end
    else        
        fprintf(1,'iter %d, %d atoms changed!\n',iterNum, sum(prev_atoms_INC~=curr_atoms_INC));
        prev_atoms_INC=curr_atoms_INC;
    end    

    prev_model = curr_model;
    pause(2)
    %fprintf(1,'consist %d, inconsist %d \n',sum(Atomtype==curr_atoms_INC),sum(Atomtype~=curr_atoms_INC));
end


beep

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
figure;hold on
plot3(curr_model(2,curr_atoms_INC==1),curr_model(1,curr_atoms_INC==1),curr_model(3,curr_atoms_INC==1),'ro');view([0 0 1]);set(gca,'Zdir','reverse','Ydir','reverse')
plot3(curr_model(2,curr_atoms_INC==vacNum),curr_model(1,curr_atoms_INC==vacNum),curr_model(3,curr_atoms_INC==vacNum),'b.');view([0 0 1]);set(gca,'Zdir','reverse','Ydir','reverse')

%% show results
atom_pos=curr_model/Res;

COM=0;

xv=[ -40.31  -105.9   -118.1  -116.2  -27.83   71.9  118.2   84.65   19.77    -40.31  ];
yv=[ -119.6  -55.34   -9.429  89.82   113.5    115.1  -20.31  -87.02 -112.8   -119.6];

edgeL=0

xv(xv<0)=xv(xv<0)+edgeL;
xv(xv>0)=xv(xv>0)-edgeL;
yv(yv<0)=yv(yv<0)+edgeL;
yv(yv>0)=yv(yv>0)-edgeL;

xv = xv+COM;
yv = yv+COM;

xq = atom_pos(2,:);
yq = atom_pos(1,:);
[in,on] = inpolygon(xq,yq,xv,yv);

figure

plot(xv,yv) % polygon
axis equal
set(gca,'Zdir','reverse','Ydir','reverse')
set(gcf, 'Position', [100, 100, 600, 600])

hold on
% plot(xq(in),yq(in),'r+') % points inside
% plot(xq(~in),yq(~in),'bo') % points outside

curr_modelPoly=curr_model(:,in)/Res;
curr_atoms_INCPoly = curr_atoms_INC(in);

plot3(curr_modelPoly(2,curr_atoms_INCPoly==1),curr_modelPoly(1,curr_atoms_INCPoly==1),curr_modelPoly(3,curr_atoms_INCPoly==1),'ro');view([0 0 1]);set(gca,'Zdir','reverse','Ydir','reverse')

plot3(curr_modelPoly(2,curr_atoms_INCPoly==vacNum),curr_modelPoly(1,curr_atoms_INCPoly==vacNum),curr_modelPoly(3,curr_atoms_INCPoly==vacNum),'b.');view([0 0 1]);set(gca,'Zdir','reverse','Ydir','reverse')

% plot3(curr_modelPoly(2,curr_atoms_INCPoly==2),curr_modelPoly(1,curr_atoms_INCPoly==2),curr_modelPoly(3,curr_atoms_INCPoly==2),'go');view([0 0 1]);set(gca,'Zdir','reverse','Ydir','reverse')
plot3(curr_modelPoly(2,curr_atoms_INCPoly==3),curr_modelPoly(1,curr_atoms_INCPoly==3),curr_modelPoly(3,curr_atoms_INCPoly==3),'b^');view([0 0 1]);set(gca,'Zdir','reverse','Ydir','reverse')

hold off
xlim([-125 125]);
ylim([-125 125]);

PJlist;
S=sum(curr_atoms_INCPoly==1)
Mo=sum(curr_atoms_INCPoly==2)
RE=sum(curr_atoms_INCPoly==3)
Svac=sum(curr_atoms_INCPoly==vacNum)


%% outside ROI no vacancy 
for outSvac = 1:length(in)
    if in(outSvac)==0 & curr_atoms_INC(outSvac)==vacNum
         curr_atoms_INC(outSvac)=1;
    end
end

%%
atoms = curr_atoms_INC;

% save DataMA_refined1_pairSwap_PJ1_5.mat model atoms

